#if defined GBUFFERS
    uniform sampler2D tex;
    uniform sampler2D normals;
    uniform sampler2D specular;
#endif

uniform sampler2D colortex0;
uniform sampler2D colortex1;
uniform sampler2D colortex2;
uniform sampler2D colortex3;
uniform sampler2D colortex4;
uniform sampler2D colortex5;
uniform sampler2D colortex6;
uniform sampler2D colortex7;
uniform sampler2D colortex8;
uniform usampler2D colortex9;

uniform sampler2D colortex10;
uniform sampler2D colortex11;
uniform sampler2D colortex12;
uniform sampler2D colortex13;
uniform sampler2D colortex14;
uniform sampler2D colortex15;

uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D depthtex2;

uniform sampler2D shadowcolor0;
uniform sampler2D shadowcolor1;

uniform sampler2D shadowtex0;
uniform sampler2D shadowtex1;

uniform sampler2D noisetex;

uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferPreviousProjection;

uniform mat4 shadowModelView;
uniform mat4 shadowModelViewInverse;

uniform mat4 shadowProjection;
uniform mat4 shadowProjectionInverse;

uniform int frameCounter;
uniform int isEyeInWater;
uniform int blockEntityId;
uniform int entityId;
uniform int heldItemId;  
uniform int worldTime;
uniform int moonPhase;
uniform int frame_8;
uniform int frame_16;

uniform ivec2 eyeBrightnessSmooth;

uniform float viewWidth;
uniform float viewHeight;
uniform float sunAngle;
uniform float eyeAltitude;
uniform float frameTime;
uniform float frameTimeCounter;
uniform float far;
uniform float near;
uniform float wetness;
uniform float screenBrightness; 
uniform float centerDepthSmooth;
uniform float aspectRatio;
uniform float damage;
uniform float world_time;
uniform float invisible;
uniform float nightVision;
uniform float blindness;

uniform float time_sunrise;
uniform float time_morning;
uniform float time_afternoon;
uniform float time_sunset;
uniform float time_midnight;

uniform vec2 texel;
uniform vec2 inverse_texel;
uniform vec2 jitter;

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 shadowLightPosition;
uniform vec3 chunkOffset;

uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;

uniform vec3 fogColor;
uniform vec3 skyColor; 

uniform vec4 entityColor;

#if defined SHADERS_VERTEX
    attribute vec4 at_tangent;
    attribute vec4 mc_Entity;
    attribute vec4 mc_midTexCoord;
#endif